'use strict';

var config = require('../__config');
var http = require("http");

var url;
var isDebug;

var tester = function(done, count){

	http.get(url, function(res) {
		isDebug && console.log(count, `Got response: ${res.statusCode}`);
		done(count);

	}).on('error', (e) => {
		console.log(`Got error: ${e.message}`);
	});
};

var runner = {
	do: function(serverName, isDebug_){
		isDebug = isDebug_;
		url = 'http://localhost:' + config.ports[serverName];

		this.go();
	},

	go: function(){
		var run = require('../../../../lib/run');
		run(config, isDebug);
		run(tester);
	}
};

module.exports = runner;
