'use strict';

var config = require('../config');
var util = require('./util');
var testers;

var main = {
	do: function(path){
		main.init(path);
		main.os();
		main.run();
	},

	init: function(path){
		var glob = require('glob');
		testers = glob.sync(path);
	},

	os: function(){
		console.log(util.getOSInfo());
	},

	run: function() {
		if (!testers.length) {
			process.exit();
		}

		var tester = testers.shift();
		var testerName = util.getTesterName(tester);
		console.log(testerName + '...');

		var fork = require('child_process').fork;
		var child = fork(tester, [testerName]);
		child.once('exit', main.run);
	}
};

module.exports = main.do;
