
var config = require('../config');

var util = {
	getOSInfo: function(){
		var os = require('os');

		return '' +
			'Platform info:\n' +
			util.getOSType() + ' ' + os.arch() + '\n' +
			os.cpus()[0].model + ' x ' + os.cpus().length + '\n' +
			'Total Memory ' + parseInt(os.totalmem() / (1024 * 1024 * 1024)) + ' GB' + '\n' +
			'Node.js ' + process.version + '\n' +
			'V8 ' + process.versions.v8 + '\n' +
			'--------------'
		;
	},

	getOSType: function(){
		var os = require('os');
		var osName = require('os-name')(os.platform(), os.release());

		if (osName.split(' ')[0] === 'macOS') {
			var info = require('macos-release')();
			return 'macOS' + ' ' + info.name + ' ' + info.version;
		}
		else {
			return os.type() + ' ' + os.release();
		}
	},

	getTesterName: function(str){
		return str.split('/').pop().replace(/\.js$/, '')
	},

	tab: function(str){
		var width = config.tabWidth;
		var tabStr;
		var space;

		if (str.length > width - 1) {
			tabStr = str.substr(0, width - 1) + ' ';
		}
		else {
			space = new Array(width - str.length + 1).join(' ');
			tabStr = str + space;
		}

		return tabStr;
	},

	sum: function (a, b) {
		return a + b;
	},

	copy: function(target, source){
		var keys = Object.keys(source);

		for (var i = 0, len = keys.length; i < len; i ++) {
			var key = keys[i];
			target[key] = source[key];
		}

		return target;
	},

	getIsBatch: function(){
		return typeof process.argv[2] !== 'undefined' && !global.isTestMySelf;
	},

	isSetDebug: function(obj){
		var type = typeof obj;
		return type === 'number' || type === 'boolean' || type === 'object' && typeof obj.isDebug !== 'undefined';
	},

	addUp: function(max){
		var count = 0;
		for (var i = 1; i <= max; i ++) {
			count += i;
		}
		return count;
	}
};

module.exports = util;
